#Define ARRAY .T.
#Define ASCANQUICK .T.
#Define GETWORD .T.
#Define STRPREPARATION  .T.

#Define  255
#Define  1

#Define   MAXSTRING  2**16
#Define   MAXWORD    255


#Define  MAXARRAYSIZE 65000


Clear
Set Status Off
Set Safety Off
Set Century On

Set Library To
Set Library To (Addbs(Justpath(Sys(16,0)))+'St_Denis') Additive

lcTempC = Datetime()
lnCTempCommun = Datetime()

#Define  4

?[   ]

If ARRAY   Or ASCANQUICK
   *      
   Dimension laArray(MAXARRAYSIZE/Iif(Version(5)<900,5,1),5)  &&     8.0 ,     16250  ,     65000 ,   5 

   lnLenCharElem = 25 &&  
   Arrayrand(@laArray, Alen(laArray, 1), 'C', lnLenCharElem, 1 ) &&      
   Arrayrand(@laArray, Alen(laArray, 1), 'N', 4, 2 ) &&      
   Arrayrand(@laArray, Alen(laArray, 1), 'D', -1, 3 ) &&      
   Arrayrand(@laArray, Alen(laArray, 1), 'T', -1, 4 ) &&        
   Arrayrand(@laArray, Alen(laArray, 1), 'Y', -1, 5 ) &&      

   If Used('Test')
      Use In Test
   Endif
   Create Table (Addbs(Sys(2023))+'Test') (ChampC C(lnLenCharElem), ChampN N(18,4), ChampD D, ChampT T, ChampY Y)
   Append From Array laArray
   ? [ Append From Array ], _Tally, [ records ]
   ? [ Alen  ], Alen(laArray,1)
   Select Test
Endif

If ARRAY &&     3-5 

   #Define CYCLEFORTESTING 10

   *!*     FoxPro     C    Select   
   ?[      ARRAYMAX(), ARRAYMIN(), ARRAYSUM(), ARRAYAVG() ], Datetime()
   lnCTemp = Datetime()

   Store 0 To lnMaxRow, lnMaxRowFoxPro
   Store 0 To lnMax, lnMaxFoxPro
   Store 0 To lnMinRow, lnMinRowFoxPro
   Store 0 To lnMin, lnMinFoxPro

   Store 0 To lnSum, lnSumFoxPro, lnAvg, lnAvgFoxPro, lnCnt, lnCntFoxPro

   Dimension laPerformance(12,5)

   For lnColumn = 1 To Alen(laArray, 2)

      lnT123 = Seconds()
      For lnJ78 = 1 To CYCLEFORTESTING
         lnMax = ARRAYMAX (@laArray, lnColumn , -1, -1, @lnMaxRow)
      Endfor
      laPerformance(1,lnColumn) = Seconds() - lnT123
      lnT123 = Seconds()
      For lnJ78 = 1 To CYCLEFORTESTING
         lnMaxFoxPro = ArrayFun(@laArray,'max',lnColumn  , -1, -1, @lnMaxRowFoxPro)
      Endfor
      laPerformance(2,lnColumn) = Seconds() - lnT123
      lnT123 = Seconds()
      For lnJ78 = 1 To CYCLEFORTESTING
         Select Max(Icase(lnColumn  = 1, ChampC, lnColumn  = 2, ChampN, lnColumn  = 3, ChampD, lnColumn  = 4, ChampT, ChampY)) From Test Into Array MaxSelect
      Endfor
      laPerformance(3,lnColumn) = Seconds() - lnT123
      lnT123 = Seconds()
      For lnJ78 = 1 To CYCLEFORTESTING
         lnMin = ARRAYMIN (@laArray, lnColumn  , -1, -1, @lnMinRow)
      Endfor
      laPerformance(4,lnColumn) = Seconds() - lnT123
      lnT123 = Seconds()
      For lnJ78 = 1 To CYCLEFORTESTING
         lnMinFoxPro = ArrayFun(@laArray,'Min', lnColumn   , -1, -1, @lnMinRowFoxPro)
      Endfor
      laPerformance(5,lnColumn) = Seconds() - lnT123
      lnT123 = Seconds()
      For lnJ78 = 1 To CYCLEFORTESTING
         Select Min(Icase(lnColumn  = 1, ChampC, lnColumn  = 2, ChampN, lnColumn  = 3, ChampD, lnColumn  = 4, ChampT, ChampY)) From Test Into Array MinSelect
      Endfor
      laPerformance(6,lnColumn) = Seconds() - lnT123
      If Inlist( lnColumn, 2, 5)
         lnT123 = Seconds()
         For lnJ78 = 1 To CYCLEFORTESTING
            lnSum = ARRAYSUM(@laArray, lnColumn , -1, -1)
         Endfor
         laPerformance(7,lnColumn) = Seconds() - lnT123
         lnT123 = Seconds()
         For lnJ78 = 1 To CYCLEFORTESTING
            lnSumFoxPro = ArrayFun(@laArray,'Sum',lnColumn  , -1, -1)
         Endfor
         laPerformance(8,lnColumn) = Seconds() - lnT123
         lnT123 = Seconds()
         For lnJ78 = 1 To CYCLEFORTESTING
            Select Sum(Icase(lnColumn  = 2, ChampN, ChampY)) From Test Into Array SumSelect
         Endfor
         laPerformance(9,lnColumn) = Seconds() - lnT123
         *----------------------------------
         lnT123 = Seconds()
         For lnJ78 = 1 To CYCLEFORTESTING
            lnAvg = ARRAYAVG(@laArray, lnColumn , -1, -1)
         Endfor
         laPerformance(10,lnColumn) = Seconds() - lnT123
         lnT123 = Seconds()
         For lnJ78 = 1 To CYCLEFORTESTING
            lnAvgFoxPro = ArrayFun(@laArray,'Avg',lnColumn  , -1, -1)
         Endfor
         laPerformance(11,lnColumn) = Seconds() - lnT123
         lnT123 = Seconds()
         For lnJ78 = 1 To CYCLEFORTESTING
            Select Avg(Icase(lnColumn  = 2, ChampN, ChampY)) From Test Into Array AvgSelect
         Endfor
         laPerformance(12,lnColumn) = Seconds() - lnT123
      Endif
   Endfor

   If Used('Performance')
      Use In Performance
   Endif
   Create Table (Addbs(Sys(2023))+'Performance.dbf') Free   (Type C(1), Function C(10), What C(3), Performanc N(10,7) )

   For lnColumn = 1 To Alen(laPerformance, 2)
      For lnR345 = 1 To Alen(laPerformance, 1)
         If Type('laPerformance(lnR345, lnColumn)') = 'N'
            Append Blank
            Replace Next 1 Type With Icase(lnColumn  = 1, 'C', lnColumn  = 2, 'N', lnColumn  = 3, 'D', lnColumn  = 4, 'T', 'Y'),;
               function  With Icase(Mod(lnR345,3) = 1, [UDF LCK], Mod(lnR345,3) = 2, [UDF FoxPro], [Select] ),;
               what With Icase(lnR345 <=3, [Max], lnR345 <=6, [Min], lnR345 <=9, [Sum], [Avg] ),;
               Performanc With laPerformance(lnR345, lnColumn)/CYCLEFORTESTING
         Endif
      Endfor
   Endfor
   Export To (Addbs(Sys(2023))+'Performance.XLS') Type Xls
   ?[     ]+Addbs(Sys(2023))+'Performance.XLS'

   ?[        ARRAYMAX(), ARRAYMIN(), ARRAYSUM(), ARRAYAVG()]
   ?[   () ]+Alltrim(Str(Datetime() - lnCTemp ))
   ?[   ]+Ttoc(lnCTemp) +[  ]+ Ttoc(Datetime())
Endif

If ASCANQUICK  &&     3-5 

   #Ifdef CYCLEFORTESTING
      #UnDefine CYCLEFORTESTING
   #Endif
   #Define CYCLEFORTESTING 10000   &&  LCK    Seek  ,          

   *!*     FoxPro     C    Select   
   ?[      ASCANQUICK(), ASCAN() ], Datetime()
   lnCTemp = Datetime()

   Dimension laPerformance(5,5)

   For lnColumn = 1 To Alen(laArray, 2)
      =Asort(laArray, lnColumn) &&    lnColumn
      QUELELEM = laArray(Int(Alen(laArray,1)/2), lnColumn) &&      ,    
      ?[lnColumn ] , lnColumn
      ?[ type ],Icase(lnColumn  = 1, 'C', lnColumn  = 2, 'N', lnColumn  = 3, 'D', lnColumn  = 4, 'T', 'Y'), [ ASCANQUICK - UDF LCK]
      lnT123 = Seconds()
      For lnJ78 = 1 To CYCLEFORTESTING
         = ASCANQUICK(@laArray, QUELELEM , -1, -1, lnColumn)
      Endfor
      laPerformance(1,lnColumn) = (Seconds() - lnT123)
      ?[ type ],Icase(lnColumn  = 1, 'C', lnColumn  = 2, 'N', lnColumn  = 3, 'D', lnColumn  = 4, 'T', 'Y'), [ ASCANQUICKF - UDF FoxPro]
      lnT123 = Seconds()
      For lnJ78 = 1 To CYCLEFORTESTING
         = ASCANQUICKF(@laArray, QUELELEM , -1, -1, lnColumn)
      Endfor
      laPerformance(2,lnColumn) = (Seconds() - lnT123)

      ?[ type ],Icase(lnColumn  = 1, 'C', lnColumn  = 2, 'N', lnColumn  = 3, 'D', lnColumn  = 4, 'T', 'Y'), [ ASCAN buit-in function FoxPro]
      lnT123 = Seconds()
      For lnJ78 = 1 To CYCLEFORTESTING/10
         = Ascan(laArray, QUELELEM , -1, -1, lnColumn)*10
      Endfor
      laPerformance(3,lnColumn) = (Seconds() - lnT123)
      Select Test
      Set Order To
      lcNomChamp = Icase(lnColumn  = 1, [ChampC], lnColumn  = 2, [ChampN], lnColumn  = 3, [ChampD], lnColumn  = 4, [ChampT], [ChampY])
      ?[ type ],Icase(lnColumn  = 1, 'C', lnColumn  = 2, 'N', lnColumn  = 3, 'D', lnColumn  = 4, 'T', 'Y'), [ Locate  buit-in command FoxPro]
      lnT123 = Seconds()
      For lnJ78 = 1 To CYCLEFORTESTING/100
         Locate For &lcNomChamp == QUELELEM
         Go Top
      Endfor
      laPerformance(4,lnColumn) = (Seconds() - lnT123)*100
      Index  On &lcNomChamp Tag (lcNomChamp)
      ?[ type ],Icase(lnColumn  = 1, 'C', lnColumn  = 2, 'N', lnColumn  = 3, 'D', lnColumn  = 4, 'T', 'Y'), [ Seek buit-in command FoxPro]
      lnT123 = Seconds()
      For lnJ78 = 1 To CYCLEFORTESTING
         Seek QUELELEM
         Go Top
      Endfor
      laPerformance(5,lnColumn) = (Seconds() - lnT123)
   Endfor


   If Used('Performance1')
      Use In Performance1
   Endif
   Create Table (Addbs(Sys(2023))+'Performance1.dbf') Free   (Type C(1), Function C(10), Performanc N(10,7) )

   For lnColumn = 1 To Alen(laPerformance, 2)
      For lnR345 = 1 To Alen(laPerformance, 1)
         If Type('laPerformance(lnR345, lnColumn)') = 'N'
            Append Blank
            Replace Next 1 Type With Icase(lnColumn  = 1, 'C', lnColumn  = 2, 'N', lnColumn  = 3, 'D', lnColumn  = 4, 'T', 'Y'),;
               function  With Icase(lnR345 = 1, [UDF LCK], lnR345 = 2, [UDF FoxPro], lnR345 = 3, [Ascan], lnR345 = 4, [Locate], [Seek] ),;
               Performanc With laPerformance(lnR345, lnColumn)/CYCLEFORTESTING
         Endif
      Endfor
   Endfor
   Export To (Addbs(Sys(2023))+'Performance1.XLS') Type Xls
   ?[     ]+Addbs(Sys(2023))+'Performance1.XLS'

   ?[         ASCANQUICK(), ASCAN() ]
   ?[  () ]+Alltrim(Str(Datetime() - lnCTemp ))
   ?[   ]+Ttoc(lnCTemp) +[  ]+ Ttoc(Datetime())
Endif

Release laArray

If GETWORD  &&     5-10 
   ?[     GETALLWORDS], Datetime()
   lnCTemp = Datetime()
   pnServerError = 0

   pcDel = Space(10)+',.!?'
   pcStr = []
   **      
   For pnI = 1 To (MAXARRAYSIZE/Iif(Version(5)<900,4,1)) &&     8.0 ,     16250  ,     65000 ,   4 
      pcWord = stringrand(2, 12) &&       a  b
      pcWord = Chrtran(pcWord, pcDel,'')  &&    ,    ,       65000
      pcStr = pcStr + pcWord + Substr(pcDel,irand(1,Len(pcDel)),irand(1,2))
   Endfor

   pcDel = Space(1)+',.!?'

   ?[      ], Len(pcStr),[   ],Int(Len(pcStr)/2**10),[ ]
   *  getallwords_for_testing       
   Local Array ArrayNameFoxProforTesting(1)
   lnBegTime = Seconds()
   lnMaxLenWordLCK = GETALLWORDS('ArrayNameLCK', pcStr , pcDel)
   lnTLCK =  (Seconds() - lnBegTime)
   ?[  ArrayNameLCK,  ]+Alltrim(Str(Alen(ArrayNameLCK ,1)))+[ ]

   lnBegTime = Seconds()
   lnMaxLenWordFoxPro = GETALLWORDS_('ArrayNameFoxPro', pcStr , pcDel)
   lnTFoxPro= (Seconds() - lnBegTime)
   ?[  ArrayNameFoxPro,  ]+Alltrim(Str(Alen(ArrayNameFoxPro,1)))+[ ]
   lnBegTime = Seconds()
   lnMaxLenWordFoxProforTesting = getallwords_for_testing(@ArrayNameFoxProforTesting, pcStr , pcDel)
   lnTFoxProforTesting = (Seconds() - lnBegTime)
   ?[  ArrayNameFoxProforTesting,  ]+Alltrim(Str(Alen(ArrayNameFoxProforTesting,1)))+[ ]
   *   Release ArrayNameFoxProforTesting, ArrayNameLCK, ArrayNameFoxPro

   ?[    FoxPro GETALLWORDS]
   ?[  ], Alltrim(Str(Datetime() - lnCTemp ))
   ?[   ]+Ttoc(lcTempC) +[  ]+ Ttoc(Datetime())

   _Cliptext = ''
   lcStr123 = [   C GETALLWORDS    () ]+Alltrim(Str(lnTLCK,12,7))+Chr(13)
   ?lcStr123
   _Cliptext = _Cliptext + lcStr123
   lcStr123 = [   FoxPro GETALLWORDS    () ]+Alltrim(Str(lnTFoxPro,12,7))+Chr(13)
   ?lcStr123
   _Cliptext = _Cliptext + lcStr123
   lcStr123 = [     FoxPro GETALLWORDS    () ]+Alltrim(Str(lnTFoxProforTesting,12,7))+Chr(13)
   ?lcStr123
   _Cliptext = _Cliptext + lcStr123
   lcStr123 = [    GETALLWORDS  FoxPro       FoxPro  ]+Alltrim(Str(lnTFoxProforTesting/lnTFoxPro,12,3))+Chr(13)
   ?lcStr123
   lcStr123 = [    GETALLWORDS  C      FoxPro  ]+Alltrim(Str(lnTFoxPro /lnTLCK,12,3))+Chr(13)
   ?lcStr123
   _Cliptext = _Cliptext + lcStr123
Endif

If STRPREPARATION  &&     5-7 
   #Define CYCLE_FORTESTING 10
   ?[     STRFILTER(), REVERSE()], Datetime()
   lnCTemp = Datetime()

   ?[   STRFILTER()]
   cExpressionSearched  =  stringrand(2**20 , 2**20)
   ?[     ]+Alltrim(Str(Len(cExpressionSearched )))

   lcFiltr = STRPREPARATION([0-9])
   * lcFiltr = STRPREPARATION([a-z])
   ?[    ]+Alltrim(Str(Len(lcFiltr)))

   lnT123 = Seconds()
   For lnJ78 = 1 To CYCLE_FORTESTING
      STRFILTER(cExpressionSearched,lcFiltr )
   Endfor
   lnStrFilter = (Seconds() - lnT123)/CYCLE_FORTESTING
   ?[ StrFilter   C   () ], lnStrFilter
   lnT123 = Seconds()
   StrFilter_(cExpressionSearched,lcFiltr )
   lnStrFilter_ = (Seconds() - lnT123)
   ?[ StrFilter   FoxPro   () ], lnStrFilter_
   ?Replicate([-],50)
   ?[   REVERSE()]
   lnT123 = Seconds()
   For lnJ78 = 1 To CYCLE_FORTESTING
      REVERSE(cExpressionSearched)
   Endfor
   lnReverse = (Seconds() - lnT123)
   ?[ REVERSE   C    () ], lnReverse

   ?[     STRFILTER(), REVERSE() ]
   ?[  () ]+Alltrim(Str(Datetime() - lnCTemp ))
   ?[   ]+Ttoc(lnCTemp) +[  ]+ Ttoc(Datetime())
Endif

*         a  b
Function stringrand
   Lparameter a, b
   If _Windows
      Local All
   Else
      Private All
   Endif
   Length=irand(a,b)
   retstring=""
   For I=1 To Length
      retstring=retstring+Chr(irand( , ))
   Endfor
   Return retstring

   *            a  b,  
Function moneyrand
   Lparameter a, b
   If _Windows
      Local All
   Else
      Private All
   Endif
   * ?' (b-a)*Rand()+a) ' ,(b-a)*Rand()+a
   Return Ntom(Round(((b-a)*Rand()+a)/10**4, 4))

   *       ( , )     a  b
Function daterand
   Lparameter a, b
   If _Windows
      Local All
   Else
      Private All
   Endif
   Return  a+irand(0, (b-a))


   *            a  b
Function urand
   Lparameter a, b
   If _Windows
      Local All
   Else
      Private All
   Endif
   Return (b-a)*Rand()+a

   *            a  b,   nDecimalPlaces 
Function urandround
   Lparameter a, b, nDecimalPlaces
   If _Windows
      Local All
   Else
      Private All
   Endif
   Return Round(((b-a)*Rand()+a)/10**nDecimalPlaces, nDecimalPlaces)

   *           i  j
Function irand
   Lparameter I, j
   If _Windows
      Local All
   Else
      Private All
   Endif
   Return Int((j-I+1)*Rand()+I)

   *     n-  (  irand)
Function digits
   Lparameter N
   If _Windows
      Local All
   Else
      Private All
   Endif
   x = 10^N
   Y = irand(0, x-1) + x
   Return Substr(Str(Y,N+1),2)

   *-----------------------------------------------------------
   *--  StrFilter_    tcString  ,     tcFilter.
   *-----------------------------------------------------------
Function StrFilter_
   Lparameters tcString, tcFilter
   Return  Chrtran(tcString, tcFilter + tcString, tcFilter)



Function GETALLWORDS_
   Lparameters lArrayName, cString, cDelimiters
   Return getallwords__(lArrayName, cString, cDelimiters, .T.)

Function getallwords2_
   Lparameters lArrayName, cString, cDelimiters
   Return getallwords__(lArrayName, cString, cDelimiters, .F.)

Function getallwords__
   Lparameters lArrayName, cString, cDelimiters, tlWhat
   *!*	     
   *!*	   
   *!*	   
   *!*	        
   *!*	    
   *!*	    cString  - cDelimiters
   *!*        cString
   Local All
   maxlengthword = 0
   Release (lArrayName)
   If Empty(cString)
      Return 0
   Else
      If Type('cDelimiters')<>'C'
         cDelimiters = Iif(tlWhat , Space(1)+Chr(9)+Chr(10)+Chr(13), Space(1))
      Else
         If .Not.tlWhat And Empty(cDelimiters )
            cDelimiters =  Space(1)
         Endif
      Endif
      Do Case
         Case Len(cDelimiters) = 0
            Dimension laArray(1,4)
            laArray(1,1) = 1
            laArray(1,2) = cString
            laArray(1,3) = 1
            laArray(1,4) = Len(cString)
            maxlengthword = Len(cString)
         Case Len(cDelimiters) >= 1
            If tlWhat &&         
               lcOnecDelimiter = Left(cDelimiters,1)
               cString = Chrtran(cString , Substr(cDelimiters,2), Replicate(lcOnecDelimiter, Len(cDelimiters) - 1))
               cDelimiters = lcOnecDelimiter
            Endif
            lnPos = 1
            lnI = 0
            wordcount = 1
            Store 1 To k, BegOfWord
            plExit = .F.
            Dimension laArray(MAXARRAYSIZE/Iif(Version(5)<900,4,1),4) &&     8.0 ,     16250  ,     65000 ,   4 
            Do While .T.
               If  k > BegOfWord
                  laArray[wordcount,1] = wordcount
                  laArray[wordcount,3] = BegOfWord   && begin of previous word
                  laArray[wordcount,4] = k-BegOfWord && length of previous word
                  laArray[wordcount,2] = Substr(cString, laArray[wordcount,3], laArray[wordcount,4])
                  If maxlengthword < laArray[wordcount, 4]
                     maxlengthword = laArray[wordcount, 4]
                  Endif
                  wordcount = wordcount + 1
                  BegOfWord = k
               Endif
               If plExit
                  Exit
               Endif
               Do While cDelimiters == Substr(cString,k,Len(cDelimiters))
                  k = k + Len(cDelimiters)
                  BegOfWord = k
               Enddo

               lnPos = At(cDelimiters, Substr(cString,k),1)
               If Empty(lnPos)
                  plExit = .T.
                  k = Len(cString) + 1
               Else
                  k = k + lnPos - 1
               Endif
            Enddo
            If .Not.Empty(maxlengthword)
               Dimension laArray(wordcount-1,4)
            Endif
      Endcase
      If .Not.Empty(maxlengthword)
         Public Array (lArrayName+'(1)')
         =Acopy(laArray, (lArrayName))
      Endif
      Return maxlengthword
   Endif


Function getallwords_for_testing
   Lparameters laArray, cString, cDelimiters
   *!*	      
   *!*	   
   *!*	   
   *!*	        
   *!*	    
   *!*	    cString  - cDelimiters
   Local All
   lnMaxLenWord = 0
   If Empty(cString)
      Dimension laArray(1)
      laArray(1) = .F.
   Else
      If Type('cDelimiters')<>'C'
         cDelimiters =  Space(1)+Chr(9)+Chr(10)+Chr(13)
      Endif
      Do Case
         Case Len(cDelimiters) = 0
            Dimension laArray(1,4)
            laArray(1,1) = 1
            laArray(1,2) = cString
            laArray(1,3) = 1
            laArray(1,4) = Len(cString)
            lnMaxLenWord = laArray(1,4)
         Case Len(cDelimiters) >= 1
            lnWordCnt = Getwordcount(cString, cDelimiters)
            If .Not.Empty(lnWordCnt)
               Dimension laArray(lnWordCnt,4)
               For lnI = 1 To lnWordCnt
                  **            ,  
                  **         +    + 1
                  lnEndPrevWord =  Iif(lnI>1, laArray(lnI-1,3)+laArray(lnI-1,4) + 1 ,1)
                  laArray(lnI,1) = lnI
                  laArray(lnI,2) = Getwordnum(Substr(cString, lnEndPrevWord ), 1, cDelimiters)
                  laArray(lnI,4) = Len(laArray(lnI,2))
                  If laArray(lnI,4) > lnMaxLenWord
                     lnMaxLenWord = laArray(lnI,4)
                  Endif
                  laArray(lnI,3) = At(laArray(lnI,2), Substr(cString, lnEndPrevWord )) + lnEndPrevWord - 1
               Endfor
            Else
               Dimension laArray(1)
               laArray(1) = .F.
            Endif
      Endcase
   Endif
   Return lnMaxLenWord


Function Elemrand  &&     
   Lparameters tcType, tnLen
   * tnLen -     ,      
   If Type('tnLen') <> 'N'
      tnColumn = 4
   Endif
   Local All
   *=Rand(-1*irand(1, 100))
   Do Case
      Case tcType= 'C'
         Return stringrand(tnLen, tnLen) &&       a  b
      Case tcType= 'N'
         Return  urandround(0, 2**32, tnLen)  &&          a  b,   nDecimalPlaces 
      Case tcType= 'Y'
         Return  moneyrand(0, 2**32)  &&          a  b,  
      Case tcType= 'D'
         Return  daterand(Date() - 30000, Date()+10000)  &&     ( , )     a  b
      Case tcType= 'T'
         Return   daterand(Datetime()-3000000000, Datetime()+100000000)  &&     ( , )     a  b
   Endcase


Function Arrayrand  &&      
   Lparameters taArray, tnSize, tcType, tnLen, tnColumn
   * tnLen -     ,      
   If Type('tnColumn') <> 'N'
      tnColumn = 1
   Endif
   Dimension taArray(tnSize, Alen(taArray,2))
   Local All
   =Rand(-1*irand(1, 100))
   For lnI=1 To Alen(taArray,1)
      Do Case
         Case tcType= 'C'
            taArray(lnI, tnColumn) = stringrand(tnLen, tnLen) &&       a  b
         Case tcType= 'N'
            taArray(lnI, tnColumn) = Iif(Rand()>0.5,1,-1)*urandround(0, 2**36, tnLen)  &&          a  b,   nDecimalPlaces 
         Case tcType= 'Y'
            taArray(lnI, tnColumn) = Iif(Rand()>0.5,1,-1)*moneyrand(0, 2**36)  &&          a  b,  
         Case tcType= 'D'
            taArray(lnI, tnColumn) =  daterand(Date() - 30000, Date()+10000)  &&     ( , )     a  b
         Case tcType= 'T'
            taArray(lnI, tnColumn) =  daterand(Datetime()-3000000000, Datetime()+100000000)  &&     ( , )     a  b
      Endcase
   Endfor

Function ArrayFun
   Parameters taArray, tcWhat, tnColumn, tnStartRow, tnRows, tnNumberOfElem
   ** tnNumberOfElem   
   **   'MIN','MAX'   
   **    ()    
   **         
   Private All
   tnNumberOfElem = 0 &&   ()  ,      ,   0
   plFlags = .F. &&       
   If Type('taArray(1)')=='U'
      Return .F.
   Endif
   If Type('tcWhat')<>'C'
      tcWhat = 'SUM'
   Endif
   tcWhat = Allt(Upper(tcWhat))
   If .Not.Inlist(tcWhat,'SUM','CNT','AVG','MIN','MAX')
      tcWhat = 'SUM'
   Endif
   If Type('tnColumn')<>'N' Or Alen(taArray, 2) = 0 &&  
      tnColumn = 1
   Endif
   If tnColumn<=0
      *       <=0
      *           
      tnColumn = 1
      plFlags = .T.
   Endif

   If Type('tnStartRow')<>'N' Or tnStartRow < 0
      tnStartRow = 1
   Endif
   If Type('tnRows')<>'N'  Or tnRows < 0
      tnRows = Alen(taArray, 1)
   Endif
   If tnStartRow > Alen(taArray, 1)
      Return .F.
   Endif
   If tnStartRow+tnRows-1 > Alen(taArray, 1)
      tnRows = Alen(taArray, 1) - tnStartRow + 1
   Endif

   tnRows = tnStartRow+tnRows-1
   Store 0 To pnCounter, pnSum, pnMin, pnMax, NumberOfElemMin, NumberOfElemMax
   Store 0 To pnCounterDateTime, pnCounterCaracter
   Store 0 To NumberOfElemMinDateTime , NumberOfElemMaxDateTime, NumberOfElemMinCaracter, NumberOfElemMaxCaracter

   pnFlagDateTime = .F.
   pnFlagNum  = .F.

   For pnj = Iif(plFlags And .Not.Empty(Alen(taArray, 2)), 1, tnColumn) To ;
         iif(plFlags And .Not.Empty(Alen(taArray, 2)), Alen(taArray, 2), tnColumn)

      For pnI = tnStartRow To tnRows
         Do Case
            Case Inlist(Type('taArray(pnI, pnj)'),'N','Y')
               If Type('taArray(pnI, pnj)') = 'N' &&           
                  pnFlagNum  = .T.
               Endif
               If pnFlagNum
                  If Type('pnMin') = 'Y'
                     pnMin = Mton(pnMin)
                  Endif
                  If Type('pnMax ') = 'Y'
                     pnMax = Mton(pnMax )
                  Endif
                  If Type('pnSum') = 'Y'
                     pnSum = Mton(pnSum)
                  Endif
                  pnNumElem = Iif(Type('taArray(pnI, pnj)') = 'Y', Mton(taArray(pnI, pnj)), taArray(pnI, pnj))
               Else
                  pnNumElem = taArray(pnI, pnj)
               Endif
               If Empty(pnCounter)
                  Store pnNumElem  To pnSum, pnMin, pnMax
                  Store pnI To NumberOfElemMin, NumberOfElemMax
               Else
                  If taArray(pnI, pnj) < pnMin
                     Store pnI To NumberOfElemMin
                  Endif
                  If taArray(pnI, pnj) > pnMax
                     Store pnI To NumberOfElemMax
                  Endif
                  pnMin = Min(pnNumElem , pnMin)
                  pnMax = Max(pnNumElem , pnMax)
                  pnSum = pnSum + pnNumElem
               Endif
               pnCounter = pnCounter + 1
            Case Inlist(Type('taArray(pnI, pnj)'),'C') And Inlist(tcWhat, 'MIN', 'MAX')
               If Empty(pnCounterCaracter)
                  Store taArray(pnI, pnj) To pcMin, pcMax
                  Store pnI To NumberOfElemMinCaracter, NumberOfElemMaxCaracter
               Else
                  If taArray(pnI, pnj) < pcMin
                     Store pnI To NumberOfElemMinCaracter
                  Endif
                  If taArray(pnI, pnj) > pcMax
                     Store pnI To NumberOfElemMaxCaracter
                  Endif
                  pcMin = Min(taArray(pnI, pnj), pcMin)
                  pcMax = Max(taArray(pnI, pnj), pcMax)
               Endif
               pnCounterCaracter = pnCounterCaracter + 1

            Case Inlist(Type('taArray(pnI, pnj)'),'D','T') And Inlist(tcWhat, 'MIN', 'MAX')
               If _Windows
                  If Type('taArray(pnI, pnj)') = 'T'
                     pnFlagDateTime = .T.
                     ptElem = taArray(pnI, pnj)
                  Else
                     ptElem = Dtot(taArray(pnI, pnj))
                  Endif
               Else
                  pnFlagDateTime = .F.
                  ptElem = taArray(pnI, pnj)
               Endif

               If Empty(pnCounterDateTime)
                  Store ptElem  To pdMin, pdMax
                  Store pnI To NumberOfElemMinDateTime, NumberOfElemMaxDateTime
               Else
                  If ptElem  < pdMin
                     Store pnI To NumberOfElemMinDateTime
                  Else
                     If ptElem  > pdMax
                        Store pnI To NumberOfElemMaxDateTime
                     Endif
                  Endif
                  pdMin = Min(ptElem , pdMin)
                  pdMax = Max(ptElem , pdMax)
               Endif
               pnCounterDateTime = pnCounterDateTime + 1

         Endcase
      Endfor
   Endfor
   If Empty(pnCounter)
      If .Not.Empty(pnCounterCaracter)  And Inlist(tcWhat, 'MIN', 'MAX')
         tcWhat= Iif(tcWhat = 'MIN', 'MINCARACTER', 'MAXCARACTER')
      Else
         If .Not.Empty(pnCounterDateTime)  And Inlist(tcWhat, 'MIN', 'MAX')
            tcWhat= Iif(tcWhat = 'MIN', 'MINDATETIME', 'MAXDATETIME')
         Else
            If tcWhat<>'CNT'
               tcWhat='NULL'
            Endif
         Endif
      Endif
   Endif

   If pnFlagNum
      If Type('pnSum') = 'Y'
         pnSum = Mton(pnSum)
      Endif
      If Type('pnMin') = 'Y'
         pnMin = Mton(pnMin)
      Endif
      If Type('pnMax') = 'Y'
         pnMax = Mton(pnMax)
      Endif
   Endif
   ** ?'tcWhat', tcWhat
   Do Case
      Case tcWhat=='NULL'
         Return .F.
      Case tcWhat=='CNT'
         Return pnCounter
      Case tcWhat=='SUM'
         Return pnSum
      Case tcWhat=='AVG'
         Return Iif(Type('pnSum') == 'Y',  Ntom(Mton(pnSum)/pnCounter)  ,pnSum/pnCounter)
      Case tcWhat=='MIN'
         tnNumberOfElem = NumberOfElemMin
         Return pnMin
      Case tcWhat=='MAX'
         tnNumberOfElem = NumberOfElemMax
         Return pnMax
      Case tcWhat=='MINCARACTER'
         tnNumberOfElem = NumberOfElemMinCaracter
         Return pcMin
      Case tcWhat=='MAXCARACTER'
         tnNumberOfElem = NumberOfElemMaxCaracter
         Return pcMax
      Case tcWhat=='MINDATETIME'
         tnNumberOfElem = NumberOfElemMinDateTime
         Return Iif(pnFlagDateTime, pdMin, Ttod(pdMin))
      Case tcWhat=='MAXDATETIME'
         tnNumberOfElem = NumberOfElemMaxDateTime
         Return Iif(pnFlagDateTime, pdMax, Ttod(pdMax))
   Endcase



   *!*	Searches an array for an element containing the same data and data type as an expression.
   *!*	ASCAN(ArrayName, eExpression [, nStartElement [, nElementsSearched [, nSearchColumn [, nFlags ]]]])
Function ASCANQUICKF
   Parameter REFARRAY,QUECHERCHE,nStartElement ,nElementsSearched ,nSearchColumn, nFlags
   Private All
   External Array REFARRAY
   If Parameters()>=6
      If Type('nFlags ')<>'N'
         Wait Windows "    ( )"
         Return 0
      Else
         nFlags = Int(nFlags)
         If .Not.Between(nFlags, 0, 15)
            Wait Windows "      (   0  15)"
            Return 0
         Endif
      Endif
   Else
      nFlags = 0
   Endif

   If Parameters()>=5
      If Type('nSearchColumn ')<>'N'
         Wait Windows "    (    )"
         Return 0
         * nSearchColumn =1
      Else
         If nSearchColumn <= 0
            **  ASCAN     ,     
            **              
            nSearchColumn =1
         Else
            If nSearchColumn > Iif(Empty(Alen(REFARRAY, 2)), 1, Alen(REFARRAY, 2))
               Wait Windows "    (        )"
               Return 0
            Endif
         Endif
      Endif
   Else
      nSearchColumn = 1
   Endif
   If Parameters()>=3
      If Type('nStartElement ')<>'N'
         Wait Windows "    (    )"
         Return 0
         * nStartElement =1
      Endif
      If nStartElement = -1
         nStartElement = 1  &&       
      Else
         If  .Not.Between(nStartElement, 1, Alen(REFARRAY,1))
            Wait Windows "    (    )"
            Return 0
         Endif
      Endif
   Else
      nStartElement = 1 &&       
   Endif
   If Parameters()>=4
      If Type('nElementsSearched')<>'N'
         Wait Windows "    (     )"
         Return 0
      Endif
      If nElementsSearched = -1
         nElementsSearched = Alen(REFARRAY,1) - nStartElement + 1   &&   -           
      Else
         If  nElementsSearched > Alen(REFARRAY,1) - nStartElement + 1
            nElementsSearched = Alen(REFARRAY,1) - nStartElement + 1
         Endif
         If nElementsSearched < -1 .Or. nElementsSearched  = 0
            Wait Windows "    (     )"
            Return 0
         Endif
      Endif
   Else
      nElementsSearched =Alen(REFARRAY,1)
   Endif

   If Alen(REFARRAY,1)<nStartElement +nElementsSearched -1
      **       
      nElementsSearched =Alen(REFARRAY,1)-nStartElement +1
   Endif
   If Empty(Alen(REFARRAY,2))
      **  
      nSearchColumn = 1
   Endif
   *!*	Bit Description
   *!*	0 Case Insensitive bit
   *!*	1 Exactness ON bit (Only effective if bit 2 is set)
   *!*	2 Override system Exact setting bit
   *!*	3 Return row number if 2D array
   pnSaveExact = Set([EXACT])
   If Bittest(nFlags, 2)
      If Bittest(nFlags, 1)
         Set Exact On
      Else
         Set Exact Off
      Endif
   Endif

   PNF=BSEARCHQUICK(@REFARRAY,(QUECHERCHE),(nSearchColumn ),(nStartElement ),(nElementsSearched ),(nFlags))
   SPNF=PNF
   Do While .Not.Empty(PNF)
      PNF=PNF-nStartElement
      If PNF=0
         Exit
      Endif
      PNF=BSEARCHQUICK(@REFARRAY,(QUECHERCHE),(nSearchColumn ),(nStartElement ),(PNF),(nFlags))
      If .Not.Empty(PNF)
         SPNF=PNF
      Endif
   Enddo
   Set Exact &pnSaveExact
   * bittest(nFlags, 3)  && Case Insensitive bit
   Return Iif(Bittest(nFlags, 3), SPNF, Iif(Empty(Alen(REFARRAY,2)), SPNF, Iif(.Not.Empty(SPNF), Aelement(REFARRAY, SPNF, nSearchColumn ), SPNF )))


Function BSEARCHQUICK
   Parameter REFARRAY, QUECHERCHE, nColsSear, nStartRow, nRowsSear, nFlags
   Private All
   External Array REFARRAY
   Low=nStartRow
   High=nStartRow+nRowsSear-1
   MID=Int((Low+High)/2)
   *!*	Bit Description
   *!*	0 Case Insensitive bit
   *!*	1 Exactness ON bit (Only effective if bit 2 is set)
   *!*	2 Override system Exact setting bit
   *!*	3 Return row number if 2D array
   * bittest(nFlags, 0)  && Case Insensitive bit
   Do While  Low<=High
      Do Case
         Case .Not.Empty(Ascan(REFARRAY,QUECHERCHE, MID, 1, nColsSear, nFlags ))
            Exit
         Case comparison(QUECHERCHE,[>=], Iif(Empty(nColsSear),REFARRAY(MID),REFARRAY(MID,nColsSear)), nFlags )
            **  Low MID+      Low  High
            Low=MID+1
         Case comparison(QUECHERCHE,[<], Iif(Empty(nColsSear),REFARRAY(MID),REFARRAY(MID,nColsSear)), nFlags )
            **  High MID-      Low  High
            High=MID-1
         Case Empty(Ascan(REFARRAY,QUECHERCHE,MID, 1, nColsSear, nFlags))
            Exit
         Otherwise
      Endcase
      MID=Int((Low+High)/2)
      If .Not.Between(MID,nStartRow,nStartRow+nRowsSear-1)
         Exit
      Endif
   Enddo
   If .Not.Between(MID,nStartRow,nStartRow+nRowsSear-1)
      MID=0
   Else
      If Empty(Ascan(REFARRAY,QUECHERCHE,MID, 1, nColsSear, nFlags))
         MID=0
      Endif
   Endif
   Return MID

Function comparison
   **  .T.    (    ,   ..) 
   Parameter  tVar1 , tcSign, tVar2, nFlags
   If Type([tVar1])==[C] And  Type([tVar2])==[C]
      If Bittest(nFlags, 0)  && Case Insensitive bit
         Return (Upper(tVar1) &tcSign Upper(tVar2)) &&   Upper,   Lower!
      Endif
   Endif
   Return (tVar1 &tcSign tVar2)
